/* xnoise-dbus-image-extraction.c generated by valac, the Vala compiler
 * generated from xnoise-dbus-image-extraction.vala, do not modify */

/* xnoise-dbus-image-extraction.vala
 *
 * Copyright (C) 2013  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define TYPE_IMAGE_EXTRACTOR (image_extractor_get_type ())
#define IMAGE_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_EXTRACTOR, ImageExtractor))
#define IS_IMAGE_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_EXTRACTOR))
#define IMAGE_EXTRACTOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_IMAGE_EXTRACTOR, ImageExtractorIface))

typedef struct _ImageExtractor ImageExtractor;
typedef struct _ImageExtractorIface ImageExtractorIface;

#define TYPE_IMAGE_EXTRACTOR_PROXY (image_extractor_proxy_get_type ())
typedef GDBusProxy ImageExtractorProxy;
typedef GDBusProxyClass ImageExtractorProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR (xnoise_dbus_image_extractor_get_type ())
#define XNOISE_DBUS_IMAGE_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR, XnoiseDbusImageExtractor))
#define XNOISE_DBUS_IMAGE_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR, XnoiseDbusImageExtractorClass))
#define XNOISE_IS_DBUS_IMAGE_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR))
#define XNOISE_IS_DBUS_IMAGE_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR))
#define XNOISE_DBUS_IMAGE_EXTRACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR, XnoiseDbusImageExtractorClass))

typedef struct _XnoiseDbusImageExtractor XnoiseDbusImageExtractor;
typedef struct _XnoiseDbusImageExtractorClass XnoiseDbusImageExtractorClass;
typedef struct _XnoiseDbusImageExtractorPrivate XnoiseDbusImageExtractorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ImageExtractorIface {
	GTypeInterface parent_iface;
	gchar* (*ping) (ImageExtractor* self, GError** error);
	void (*add_uris) (ImageExtractor* self, gchar** uris, int uris_length1, GError** error);
	guint (*get_waiting_jobs) (ImageExtractor* self);
	void (*set_waiting_jobs) (ImageExtractor* self, guint value);
};

struct _XnoiseDbusImageExtractor {
	GObject parent_instance;
	XnoiseDbusImageExtractorPrivate * priv;
};

struct _XnoiseDbusImageExtractorClass {
	GObjectClass parent_class;
};

struct _XnoiseDbusImageExtractorPrivate {
	guint watch;
	ImageExtractor* extractor_proxy;
	ImageExtractor* iextr;
	gulong ready_sign_handler_id;
};


static gpointer xnoise_dbus_image_extractor_parent_class = NULL;

GType image_extractor_proxy_get_type (void) G_GNUC_CONST;
guint image_extractor_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType image_extractor_get_type (void) G_GNUC_CONST;
gchar* image_extractor_ping (ImageExtractor* self, GError** error);
void image_extractor_add_uris (ImageExtractor* self, gchar** uris, int uris_length1, GError** error);
#define IMAGE_EXTRACTOR_UNIQUE_NAME "org.gtk.xnoise.ImageExtractor"
#define IMAGE_EXTRACTOR_OBJECT_PATH "/ImageExtractor"
guint image_extractor_get_waiting_jobs (ImageExtractor* self);
void image_extractor_set_waiting_jobs (ImageExtractor* self, guint value);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void image_extractor_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_image_extractor_found_image (ImageExtractor* self, GVariant* parameters);
static gchar* image_extractor_proxy_ping (ImageExtractor* self, GError** error);
static void image_extractor_proxy_add_uris (ImageExtractor* self, gchar** uris, int uris_length1, GError** error);
static guint image_extractor_dbus_proxy_get_waiting_jobs (ImageExtractor* self);
static void image_extractor_dbus_proxy_set_waiting_jobs (ImageExtractor* self, guint value);
static void image_extractor_proxy_image_extractor_interface_init (ImageExtractorIface* iface);
static void _dbus_image_extractor_ping (ImageExtractor* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_image_extractor_add_uris (ImageExtractor* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void image_extractor_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* image_extractor_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_image_extractor_get_waiting_jobs (ImageExtractor* self);
static gboolean image_extractor_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_image_extractor_set_waiting_jobs (ImageExtractor* self, GVariant* _value);
static void _dbus_image_extractor_found_image (GObject* _sender, const gchar* artist, const gchar* album, const gchar* image, gpointer* _data);
static void _image_extractor_unregister_object (gpointer user_data);
GType xnoise_dbus_image_extractor_get_type (void) G_GNUC_CONST;
#define XNOISE_DBUS_IMAGE_EXTRACTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR, XnoiseDbusImageExtractorPrivate))
enum  {
	XNOISE_DBUS_IMAGE_EXTRACTOR_DUMMY_PROPERTY
};
XnoiseDbusImageExtractor* xnoise_dbus_image_extractor_new (void);
XnoiseDbusImageExtractor* xnoise_dbus_image_extractor_construct (GType object_type);
static void xnoise_dbus_image_extractor_get_dbus (XnoiseDbusImageExtractor* self);
void xnoise_dbus_image_extractor_queue_uris (XnoiseDbusImageExtractor* self, gchar** uris, int uris_length1);
static void xnoise_dbus_image_extractor_on_name_appeared (XnoiseDbusImageExtractor* self, GDBusConnection* conn, const gchar* name);
static gboolean __lambda8_ (XnoiseDbusImageExtractor* self);
static void xnoise_dbus_image_extractor_on_found_image (XnoiseDbusImageExtractor* self, const gchar* artist, const gchar* album, const gchar* image);
static void _xnoise_dbus_image_extractor_on_found_image_image_extractor_found_image (ImageExtractor* _sender, const gchar* artist, const gchar* album, const gchar* image, gpointer self);
static gboolean ___lambda8__gsource_func (gpointer self);
static void xnoise_dbus_image_extractor_on_name_vanished (XnoiseDbusImageExtractor* self, GDBusConnection* conn, const gchar* name);
static void _xnoise_dbus_image_extractor_on_name_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self);
static void _xnoise_dbus_image_extractor_on_name_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void xnoise_dbus_image_extractor_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo _image_extractor_dbus_arg_info_ping_result = {-1, "result", "s"};
static const GDBusArgInfo * const _image_extractor_dbus_arg_info_ping_in[] = {NULL};
static const GDBusArgInfo * const _image_extractor_dbus_arg_info_ping_out[] = {&_image_extractor_dbus_arg_info_ping_result, NULL};
static const GDBusMethodInfo _image_extractor_dbus_method_info_ping = {-1, "Ping", (GDBusArgInfo **) (&_image_extractor_dbus_arg_info_ping_in), (GDBusArgInfo **) (&_image_extractor_dbus_arg_info_ping_out)};
static const GDBusArgInfo _image_extractor_dbus_arg_info_add_uris_uris = {-1, "uris", "as"};
static const GDBusArgInfo * const _image_extractor_dbus_arg_info_add_uris_in[] = {&_image_extractor_dbus_arg_info_add_uris_uris, NULL};
static const GDBusArgInfo * const _image_extractor_dbus_arg_info_add_uris_out[] = {NULL};
static const GDBusMethodInfo _image_extractor_dbus_method_info_add_uris = {-1, "AddUris", (GDBusArgInfo **) (&_image_extractor_dbus_arg_info_add_uris_in), (GDBusArgInfo **) (&_image_extractor_dbus_arg_info_add_uris_out)};
static const GDBusMethodInfo * const _image_extractor_dbus_method_info[] = {&_image_extractor_dbus_method_info_ping, &_image_extractor_dbus_method_info_add_uris, NULL};
static const GDBusArgInfo _image_extractor_dbus_arg_info_found_image_artist = {-1, "artist", "s"};
static const GDBusArgInfo _image_extractor_dbus_arg_info_found_image_album = {-1, "album", "s"};
static const GDBusArgInfo _image_extractor_dbus_arg_info_found_image_image = {-1, "image", "s"};
static const GDBusArgInfo * const _image_extractor_dbus_arg_info_found_image[] = {&_image_extractor_dbus_arg_info_found_image_artist, &_image_extractor_dbus_arg_info_found_image_album, &_image_extractor_dbus_arg_info_found_image_image, NULL};
static const GDBusSignalInfo _image_extractor_dbus_signal_info_found_image = {-1, "FoundImage", (GDBusArgInfo **) (&_image_extractor_dbus_arg_info_found_image)};
static const GDBusSignalInfo * const _image_extractor_dbus_signal_info[] = {&_image_extractor_dbus_signal_info_found_image, NULL};
static const GDBusPropertyInfo _image_extractor_dbus_property_info_waiting_jobs = {-1, "WaitingJobs", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo * const _image_extractor_dbus_property_info[] = {&_image_extractor_dbus_property_info_waiting_jobs, NULL};
static const GDBusInterfaceInfo _image_extractor_dbus_interface_info = {-1, "org.gtk.xnoise.ImageExtractor", (GDBusMethodInfo **) (&_image_extractor_dbus_method_info), (GDBusSignalInfo **) (&_image_extractor_dbus_signal_info), (GDBusPropertyInfo **) (&_image_extractor_dbus_property_info)};
static const GDBusInterfaceVTable _image_extractor_dbus_interface_vtable = {image_extractor_dbus_interface_method_call, image_extractor_dbus_interface_get_property, image_extractor_dbus_interface_set_property};

gchar* image_extractor_ping (ImageExtractor* self, GError** error) {
	g_return_val_if_fail (IS_IMAGE_EXTRACTOR (self), NULL);
	return IMAGE_EXTRACTOR_GET_INTERFACE (self)->ping (self, error);
}


void image_extractor_add_uris (ImageExtractor* self, gchar** uris, int uris_length1, GError** error) {
	g_return_if_fail (IS_IMAGE_EXTRACTOR (self));
	IMAGE_EXTRACTOR_GET_INTERFACE (self)->add_uris (self, uris, uris_length1, error);
}


guint image_extractor_get_waiting_jobs (ImageExtractor* self) {
	g_return_val_if_fail (IS_IMAGE_EXTRACTOR (self), 0U);
	return IMAGE_EXTRACTOR_GET_INTERFACE (self)->get_waiting_jobs (self);
}


void image_extractor_set_waiting_jobs (ImageExtractor* self, guint value) {
	g_return_if_fail (IS_IMAGE_EXTRACTOR (self));
	IMAGE_EXTRACTOR_GET_INTERFACE (self)->set_waiting_jobs (self, value);
}


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
}


static void image_extractor_base_init (ImageExtractorIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("found_image", TYPE_IMAGE_EXTRACTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
	}
}


GType image_extractor_get_type (void) {
	static volatile gsize image_extractor_type_id__volatile = 0;
	if (g_once_init_enter (&image_extractor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageExtractorIface), (GBaseInitFunc) image_extractor_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType image_extractor_type_id;
		image_extractor_type_id = g_type_register_static (G_TYPE_INTERFACE, "ImageExtractor", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (image_extractor_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (image_extractor_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) image_extractor_proxy_get_type);
		g_type_set_qdata (image_extractor_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gtk.xnoise.ImageExtractor");
		g_type_set_qdata (image_extractor_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) image_extractor_register_object);
		g_once_init_leave (&image_extractor_type_id__volatile, image_extractor_type_id);
	}
	return image_extractor_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (ImageExtractorProxy, image_extractor_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_IMAGE_EXTRACTOR, image_extractor_proxy_image_extractor_interface_init) )
static void image_extractor_proxy_class_init (ImageExtractorProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = image_extractor_proxy_g_signal;
}


static void _dbus_handle_image_extractor_found_image (ImageExtractor* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* artist = NULL;
	GVariant* _tmp5_;
	gchar* album = NULL;
	GVariant* _tmp6_;
	gchar* image = NULL;
	GVariant* _tmp7_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	artist = g_variant_dup_string (_tmp5_, NULL);
	g_variant_unref (_tmp5_);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	album = g_variant_dup_string (_tmp6_, NULL);
	g_variant_unref (_tmp6_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	image = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	g_signal_emit_by_name (self, "found-image", artist, album, image);
	_g_free0 (artist);
	_g_free0 (album);
	_g_free0 (image);
}


static void image_extractor_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "FoundImage") == 0) {
		_dbus_handle_image_extractor_found_image ((ImageExtractor*) proxy, parameters);
	}
}


static void image_extractor_proxy_init (ImageExtractorProxy* self) {
}


static gchar* image_extractor_proxy_ping (ImageExtractor* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp8_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gtk.xnoise.ImageExtractor", "Ping");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp8_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	g_object_unref (_reply_message);
	return _result;
}


static void image_extractor_proxy_add_uris (ImageExtractor* self, gchar** uris, int uris_length1, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp9_;
	GVariantBuilder _tmp10_;
	int _tmp11_;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gtk.xnoise.ImageExtractor", "AddUris");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp9_ = uris;
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("as"));
	for (_tmp11_ = 0; _tmp11_ < uris_length1; _tmp11_++) {
		g_variant_builder_add_value (&_tmp10_, g_variant_new_string (*_tmp9_));
		_tmp9_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp10_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static guint image_extractor_dbus_proxy_get_waiting_jobs (ImageExtractor* self) {
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "WaitingJobs");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gtk.xnoise.ImageExtractor"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("WaitingJobs"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return 0U;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void image_extractor_dbus_proxy_set_waiting_jobs (ImageExtractor* self, guint value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gtk.xnoise.ImageExtractor"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("WaitingJobs"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static void image_extractor_proxy_image_extractor_interface_init (ImageExtractorIface* iface) {
	iface->ping = image_extractor_proxy_ping;
	iface->add_uris = image_extractor_proxy_add_uris;
	iface->get_waiting_jobs = image_extractor_dbus_proxy_get_waiting_jobs;
	iface->set_waiting_jobs = image_extractor_dbus_proxy_set_waiting_jobs;
}


static void _dbus_image_extractor_ping (ImageExtractor* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = image_extractor_ping (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_image_extractor_add_uris (ImageExtractor* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** uris = NULL;
	int uris_length1 = 0;
	GVariant* _tmp12_;
	gchar** _tmp13_;
	int _tmp13__length;
	int _tmp13__size;
	int _tmp13__length1;
	GVariantIter _tmp14_;
	GVariant* _tmp15_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp13_ = g_new (gchar*, 5);
	_tmp13__length = 0;
	_tmp13__size = 4;
	_tmp13__length1 = 0;
	g_variant_iter_init (&_tmp14_, _tmp12_);
	for (; (_tmp15_ = g_variant_iter_next_value (&_tmp14_)) != NULL; _tmp13__length1++) {
		if (_tmp13__size == _tmp13__length) {
			_tmp13__size = 2 * _tmp13__size;
			_tmp13_ = g_renew (gchar*, _tmp13_, _tmp13__size + 1);
		}
		_tmp13_[_tmp13__length++] = g_variant_dup_string (_tmp15_, NULL);
		g_variant_unref (_tmp15_);
	}
	uris_length1 = _tmp13__length1;
	_tmp13_[_tmp13__length] = NULL;
	uris = _tmp13_;
	g_variant_unref (_tmp12_);
	image_extractor_add_uris (self, uris, uris_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void image_extractor_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Ping") == 0) {
		_dbus_image_extractor_ping (object, parameters, invocation);
	} else if (strcmp (method_name, "AddUris") == 0) {
		_dbus_image_extractor_add_uris (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_image_extractor_get_waiting_jobs (ImageExtractor* self) {
	guint result;
	GVariant* _reply;
	result = image_extractor_get_waiting_jobs (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant* image_extractor_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "WaitingJobs") == 0) {
		return _dbus_image_extractor_get_waiting_jobs (object);
	}
	return NULL;
}


static void _dbus_image_extractor_set_waiting_jobs (ImageExtractor* self, GVariant* _value) {
	guint value = 0U;
	value = g_variant_get_uint32 (_value);
	image_extractor_set_waiting_jobs (self, value);
}


static gboolean image_extractor_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "WaitingJobs") == 0) {
		_dbus_image_extractor_set_waiting_jobs (object, value);
		return TRUE;
	}
	return FALSE;
}


static void _dbus_image_extractor_found_image (GObject* _sender, const gchar* artist, const gchar* album, const gchar* image, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (artist));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (album));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (image));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gtk.xnoise.ImageExtractor", "FoundImage", _arguments, NULL);
}


guint image_extractor_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_image_extractor_dbus_interface_info), &_image_extractor_dbus_interface_vtable, data, _image_extractor_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "found-image", (GCallback) _dbus_image_extractor_found_image, data);
	return result;
}


static void _image_extractor_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_image_extractor_found_image, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


XnoiseDbusImageExtractor* xnoise_dbus_image_extractor_construct (GType object_type) {
	XnoiseDbusImageExtractor * self = NULL;
	self = (XnoiseDbusImageExtractor*) g_object_new (object_type, NULL);
	xnoise_dbus_image_extractor_get_dbus (self);
	return self;
}


XnoiseDbusImageExtractor* xnoise_dbus_image_extractor_new (void) {
	return xnoise_dbus_image_extractor_construct (XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR);
}


void xnoise_dbus_image_extractor_queue_uris (XnoiseDbusImageExtractor* self, gchar** uris, int uris_length1) {
	gboolean _tmp0_ = FALSE;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (XNOISE_IS_DBUS_IMAGE_EXTRACTOR (self));
	_tmp1_ = uris;
	_tmp1__length1 = uris_length1;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		_tmp2_ = uris;
		_tmp2__length1 = uris_length1;
		_tmp0_ = _tmp2__length1 == 0;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		return;
	}
	{
		ImageExtractor* _tmp4_;
		ImageExtractor* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		_tmp4_ = self->priv->iextr;
		if (_tmp4_ == NULL) {
			ImageExtractor* _tmp5_ = NULL;
			ImageExtractor* _tmp6_;
			_tmp5_ = g_initable_new (TYPE_IMAGE_EXTRACTOR_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", IMAGE_EXTRACTOR_UNIQUE_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", IMAGE_EXTRACTOR_OBJECT_PATH, "g-interface-name", "org.gtk.xnoise.ImageExtractor", NULL);
			_tmp6_ = (ImageExtractor*) _tmp5_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch10_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_g_object_unref0 (self->priv->iextr);
			self->priv->iextr = _tmp6_;
		}
		_tmp7_ = self->priv->iextr;
		_tmp8_ = uris;
		_tmp8__length1 = uris_length1;
		image_extractor_add_uris (_tmp7_, _tmp8_, _tmp8__length1, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch10_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally10;
	__catch10_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = stderr;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		fprintf (_tmp9_, "Service is not available.\n%s", _tmp11_);
		_g_error_free0 (e);
		return;
	}
	__finally10:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _xnoise_dbus_image_extractor_on_found_image_image_extractor_found_image (ImageExtractor* _sender, const gchar* artist, const gchar* album, const gchar* image, gpointer self) {
	xnoise_dbus_image_extractor_on_found_image (self, artist, album, image);
}


static gboolean __lambda8_ (XnoiseDbusImageExtractor* self) {
	gboolean result = FALSE;
	ImageExtractor* _tmp0_;
	_tmp0_ = self->priv->iextr;
	if (_tmp0_ != NULL) {
		ImageExtractor* _tmp1_;
		gulong _tmp2_ = 0UL;
		_tmp1_ = self->priv->iextr;
		_tmp2_ = g_signal_connect_object (_tmp1_, "found-image", (GCallback) _xnoise_dbus_image_extractor_on_found_image_image_extractor_found_image, self, 0);
		self->priv->ready_sign_handler_id = _tmp2_;
	}
	result = FALSE;
	return result;
}


static gboolean ___lambda8__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda8_ (self);
	return result;
}


static void xnoise_dbus_image_extractor_on_name_appeared (XnoiseDbusImageExtractor* self, GDBusConnection* conn, const gchar* name) {
	g_return_if_fail (XNOISE_IS_DBUS_IMAGE_EXTRACTOR (self));
	g_return_if_fail (G_IS_DBUS_CONNECTION (conn));
	g_return_if_fail (name != NULL);
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ___lambda8__gsource_func, g_object_ref (self), g_object_unref);
}


static void xnoise_dbus_image_extractor_on_name_vanished (XnoiseDbusImageExtractor* self, GDBusConnection* conn, const gchar* name) {
	gboolean _tmp0_ = FALSE;
	ImageExtractor* _tmp1_;
	gboolean _tmp3_;
	g_return_if_fail (XNOISE_IS_DBUS_IMAGE_EXTRACTOR (self));
	g_return_if_fail (G_IS_DBUS_CONNECTION (conn));
	g_return_if_fail (name != NULL);
	_tmp1_ = self->priv->iextr;
	if (_tmp1_ != NULL) {
		gulong _tmp2_;
		_tmp2_ = self->priv->ready_sign_handler_id;
		_tmp0_ = _tmp2_ != ((gulong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		ImageExtractor* _tmp4_;
		gulong _tmp5_;
		_tmp4_ = self->priv->iextr;
		_tmp5_ = self->priv->ready_sign_handler_id;
		g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, G_TYPE_OBJECT, GObject), _tmp5_);
	}
	self->priv->ready_sign_handler_id = (gulong) 0;
	_g_object_unref0 (self->priv->iextr);
	self->priv->iextr = NULL;
}


static void _xnoise_dbus_image_extractor_on_name_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self) {
	xnoise_dbus_image_extractor_on_name_appeared (self, connection, name);
}


static void _xnoise_dbus_image_extractor_on_name_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_dbus_image_extractor_on_name_vanished (self, connection, name);
}


static void xnoise_dbus_image_extractor_get_dbus (XnoiseDbusImageExtractor* self) {
	guint _tmp0_ = 0U;
	g_return_if_fail (XNOISE_IS_DBUS_IMAGE_EXTRACTOR (self));
	_tmp0_ = g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, IMAGE_EXTRACTOR_UNIQUE_NAME, G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_xnoise_dbus_image_extractor_on_name_appeared_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_dbus_image_extractor_on_name_appeared_gbus_name_appeared_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_xnoise_dbus_image_extractor_on_name_vanished_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_dbus_image_extractor_on_name_vanished_gbus_name_vanished_callback, g_object_ref (self), g_object_unref)));
	self->priv->watch = _tmp0_;
}


static void xnoise_dbus_image_extractor_on_found_image (XnoiseDbusImageExtractor* self, const gchar* artist, const gchar* album, const gchar* image) {
	const gchar* _tmp0_;
	g_return_if_fail (XNOISE_IS_DBUS_IMAGE_EXTRACTOR (self));
	g_return_if_fail (artist != NULL);
	g_return_if_fail (album != NULL);
	g_return_if_fail (image != NULL);
	_tmp0_ = image;
	g_signal_emit_by_name (self, "sign-found-album-image", _tmp0_);
}


static void xnoise_dbus_image_extractor_class_init (XnoiseDbusImageExtractorClass * klass) {
	xnoise_dbus_image_extractor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseDbusImageExtractorPrivate));
	G_OBJECT_CLASS (klass)->finalize = xnoise_dbus_image_extractor_finalize;
	g_signal_new ("sign_found_album_image", XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void xnoise_dbus_image_extractor_instance_init (XnoiseDbusImageExtractor * self) {
	self->priv = XNOISE_DBUS_IMAGE_EXTRACTOR_GET_PRIVATE (self);
	self->priv->watch = (guint) 0;
	self->priv->extractor_proxy = NULL;
	self->priv->ready_sign_handler_id = (gulong) 0;
}


static void xnoise_dbus_image_extractor_finalize (GObject* obj) {
	XnoiseDbusImageExtractor * self;
	guint _tmp0_;
	gboolean _tmp2_ = FALSE;
	ImageExtractor* _tmp3_;
	gboolean _tmp5_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_TYPE_DBUS_IMAGE_EXTRACTOR, XnoiseDbusImageExtractor);
	_tmp0_ = self->priv->watch;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->watch;
		g_bus_unwatch_name (_tmp1_);
	}
	_tmp3_ = self->priv->iextr;
	if (_tmp3_ != NULL) {
		gulong _tmp4_;
		_tmp4_ = self->priv->ready_sign_handler_id;
		_tmp2_ = _tmp4_ != ((gulong) 0);
	} else {
		_tmp2_ = FALSE;
	}
	_tmp5_ = _tmp2_;
	if (_tmp5_) {
		ImageExtractor* _tmp6_;
		gulong _tmp7_;
		_tmp6_ = self->priv->iextr;
		_tmp7_ = self->priv->ready_sign_handler_id;
		g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, G_TYPE_OBJECT, GObject), _tmp7_);
	}
	self->priv->ready_sign_handler_id = (gulong) 0;
	_g_object_unref0 (self->priv->iextr);
	self->priv->iextr = NULL;
	_g_object_unref0 (self->priv->extractor_proxy);
	_g_object_unref0 (self->priv->iextr);
	G_OBJECT_CLASS (xnoise_dbus_image_extractor_parent_class)->finalize (obj);
}


GType xnoise_dbus_image_extractor_get_type (void) {
	static volatile gsize xnoise_dbus_image_extractor_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_dbus_image_extractor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (XnoiseDbusImageExtractorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_dbus_image_extractor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseDbusImageExtractor), 0, (GInstanceInitFunc) xnoise_dbus_image_extractor_instance_init, NULL };
		GType xnoise_dbus_image_extractor_type_id;
		xnoise_dbus_image_extractor_type_id = g_type_register_static (G_TYPE_OBJECT, "XnoiseDbusImageExtractor", &g_define_type_info, 0);
		g_once_init_leave (&xnoise_dbus_image_extractor_type_id__volatile, xnoise_dbus_image_extractor_type_id);
	}
	return xnoise_dbus_image_extractor_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



