/* xnoise-track-data.c generated by valac, the Vala compiler
 * generated from xnoise-track-data.vala, do not modify */

/* xnoise-track-data.vala
 *
 * Copyright (C) 2011-2012  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */
/* DATA TRANSFER CLASS*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gobject/gvaluecollector.h>


#define XNOISE_TYPE_TRACK_DATA (xnoise_track_data_get_type ())
#define XNOISE_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackData))
#define XNOISE_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))
#define XNOISE_IS_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_IS_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_TRACK_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))

typedef struct _XnoiseTrackData XnoiseTrackData;
typedef struct _XnoiseTrackDataClass XnoiseTrackDataClass;
typedef struct _XnoiseTrackDataPrivate XnoiseTrackDataPrivate;

#define XNOISE_TYPE_ITEM (xnoise_item_get_type ())

#define XNOISE_TYPE_ITEM_TYPE (xnoise_item_type_get_type ())
typedef struct _XnoiseItem XnoiseItem;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _xnoise_item_free0(var) ((var == NULL) ? NULL : (var = (xnoise_item_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _XnoiseParamSpecTrackData XnoiseParamSpecTrackData;
#define _xnoise_track_data_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_track_data_unref (var), NULL)))

typedef enum  {
	XNOISE_ITEM_TYPE_UNKNOWN = 0,
	XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK,
	XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK,
	XNOISE_ITEM_TYPE_STREAM,
	XNOISE_ITEM_TYPE_CDROM_TRACK,
	XNOISE_ITEM_TYPE_PLAYLIST,
	XNOISE_ITEM_TYPE_LOCAL_FOLDER,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUMARTIST,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_GENRE,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_YEAR,
	XNOISE_ITEM_TYPE_LOADER
} XnoiseItemType;

struct _XnoiseItem {
	XnoiseItemType type;
	guint32 stamp;
	gint32 db_id;
	gchar* uri;
	gchar* text;
	gchar* text2;
	gint source_id;
};

struct _XnoiseTrackData {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XnoiseTrackDataPrivate * priv;
	gchar* artist;
	gchar* albumartist;
	gchar* album;
	gchar* title;
	gchar* genre;
	gchar* name;
	gchar* mimetype;
	gint disk_number;
	guint year;
	guint tracknumber;
	gint32 length;
	gint bitrate;
	gboolean is_compilation;
	gboolean has_embedded_image;
	XnoiseItem* item;
	GdkPixbuf* pixbuf;
	gint32 dat1;
	gint32 dat2;
	gint32 dat3;
};

struct _XnoiseTrackDataClass {
	GTypeClass parent_class;
	void (*finalize) (XnoiseTrackData *self);
};

struct _XnoiseParamSpecTrackData {
	GParamSpec parent_instance;
};


static gpointer xnoise_track_data_parent_class = NULL;

gpointer xnoise_track_data_ref (gpointer instance);
void xnoise_track_data_unref (gpointer instance);
GParamSpec* xnoise_param_spec_track_data (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_value_set_track_data (GValue* value, gpointer v_object);
void xnoise_value_take_track_data (GValue* value, gpointer v_object);
gpointer xnoise_value_get_track_data (const GValue* value);
GType xnoise_track_data_get_type (void) G_GNUC_CONST;
GType xnoise_item_get_type (void) G_GNUC_CONST;
GType xnoise_item_type_get_type (void) G_GNUC_CONST;
XnoiseItem* xnoise_item_dup (const XnoiseItem* self);
void xnoise_item_free (XnoiseItem* self);
void xnoise_item_copy (const XnoiseItem* self, XnoiseItem* dest);
void xnoise_item_destroy (XnoiseItem* self);
enum  {
	XNOISE_TRACK_DATA_DUMMY_PROPERTY
};
void xnoise_item_init (XnoiseItem *self, XnoiseItemType _type, const gchar* _uri, gint32 _db_id);
XnoiseTrackData* xnoise_track_data_new (void);
XnoiseTrackData* xnoise_track_data_construct (GType object_type);
static void xnoise_track_data_finalize (XnoiseTrackData* obj);
XnoiseTrackData* xnoise_copy_trackdata (XnoiseTrackData* td);


static gpointer _xnoise_item_dup0 (gpointer self) {
	return self ? xnoise_item_dup (self) : NULL;
}


XnoiseTrackData* xnoise_track_data_construct (GType object_type) {
	XnoiseTrackData* self = NULL;
	self = (XnoiseTrackData*) g_type_create_instance (object_type);
	return self;
}


XnoiseTrackData* xnoise_track_data_new (void) {
	return xnoise_track_data_construct (XNOISE_TYPE_TRACK_DATA);
}


static void xnoise_value_track_data_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void xnoise_value_track_data_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		xnoise_track_data_unref (value->data[0].v_pointer);
	}
}


static void xnoise_value_track_data_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = xnoise_track_data_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer xnoise_value_track_data_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* xnoise_value_track_data_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		XnoiseTrackData* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = xnoise_track_data_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* xnoise_value_track_data_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	XnoiseTrackData** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = xnoise_track_data_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* xnoise_param_spec_track_data (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	XnoiseParamSpecTrackData* spec;
	g_return_val_if_fail (g_type_is_a (object_type, XNOISE_TYPE_TRACK_DATA), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer xnoise_value_get_track_data (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_TYPE_TRACK_DATA), NULL);
	return value->data[0].v_pointer;
}


void xnoise_value_set_track_data (GValue* value, gpointer v_object) {
	XnoiseTrackData* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_TYPE_TRACK_DATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_TYPE_TRACK_DATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		xnoise_track_data_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_track_data_unref (old);
	}
}


void xnoise_value_take_track_data (GValue* value, gpointer v_object) {
	XnoiseTrackData* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_TYPE_TRACK_DATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_TYPE_TRACK_DATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_track_data_unref (old);
	}
}


static void xnoise_track_data_class_init (XnoiseTrackDataClass * klass) {
	xnoise_track_data_parent_class = g_type_class_peek_parent (klass);
	XNOISE_TRACK_DATA_CLASS (klass)->finalize = xnoise_track_data_finalize;
}


static void xnoise_track_data_instance_init (XnoiseTrackData * self) {
	XnoiseItem _tmp0_ = {0};
	XnoiseItem _tmp1_;
	XnoiseItem* _tmp2_;
	self->artist = NULL;
	self->albumartist = NULL;
	self->album = NULL;
	self->title = NULL;
	self->genre = NULL;
	self->name = NULL;
	self->mimetype = NULL;
	self->disk_number = 1;
	self->year = (guint) 0;
	self->tracknumber = (guint) 0;
	self->length = (gint32) 0;
	self->bitrate = 0;
	self->is_compilation = FALSE;
	self->has_embedded_image = FALSE;
	xnoise_item_init (&_tmp0_, XNOISE_ITEM_TYPE_UNKNOWN, NULL, (gint32) (-1));
	_tmp1_ = _tmp0_;
	_tmp2_ = _xnoise_item_dup0 (&_tmp1_);
	self->item = _tmp2_;
	xnoise_item_destroy (&_tmp1_);
	self->pixbuf = NULL;
	self->dat1 = (gint32) (-1);
	self->dat2 = (gint32) (-1);
	self->dat3 = (gint32) (-1);
	self->ref_count = 1;
}


static void xnoise_track_data_finalize (XnoiseTrackData* obj) {
	XnoiseTrackData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_TYPE_TRACK_DATA, XnoiseTrackData);
	_g_free0 (self->artist);
	_g_free0 (self->albumartist);
	_g_free0 (self->album);
	_g_free0 (self->title);
	_g_free0 (self->genre);
	_g_free0 (self->name);
	_g_free0 (self->mimetype);
	_xnoise_item_free0 (self->item);
	_g_object_unref0 (self->pixbuf);
}


GType xnoise_track_data_get_type (void) {
	static volatile gsize xnoise_track_data_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_track_data_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { xnoise_value_track_data_init, xnoise_value_track_data_free_value, xnoise_value_track_data_copy_value, xnoise_value_track_data_peek_pointer, "p", xnoise_value_track_data_collect_value, "p", xnoise_value_track_data_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (XnoiseTrackDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_track_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseTrackData), 0, (GInstanceInitFunc) xnoise_track_data_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType xnoise_track_data_type_id;
		xnoise_track_data_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XnoiseTrackData", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&xnoise_track_data_type_id__volatile, xnoise_track_data_type_id);
	}
	return xnoise_track_data_type_id__volatile;
}


gpointer xnoise_track_data_ref (gpointer instance) {
	XnoiseTrackData* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void xnoise_track_data_unref (gpointer instance) {
	XnoiseTrackData* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		XNOISE_TRACK_DATA_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


XnoiseTrackData* xnoise_copy_trackdata (XnoiseTrackData* td) {
	XnoiseTrackData* result = NULL;
	XnoiseTrackData* _tmp0_;
	XnoiseTrackData* _tmp2_;
	XnoiseTrackData* td_new;
	XnoiseTrackData* _tmp3_;
	XnoiseTrackData* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	XnoiseTrackData* _tmp7_;
	XnoiseTrackData* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	XnoiseTrackData* _tmp11_;
	XnoiseTrackData* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	XnoiseTrackData* _tmp15_;
	XnoiseTrackData* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	XnoiseTrackData* _tmp19_;
	XnoiseTrackData* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	XnoiseTrackData* _tmp23_;
	XnoiseTrackData* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	XnoiseTrackData* _tmp27_;
	XnoiseTrackData* _tmp28_;
	gint _tmp29_;
	XnoiseTrackData* _tmp30_;
	XnoiseTrackData* _tmp31_;
	guint _tmp32_;
	XnoiseTrackData* _tmp33_;
	XnoiseTrackData* _tmp34_;
	guint _tmp35_;
	XnoiseTrackData* _tmp36_;
	XnoiseTrackData* _tmp37_;
	gint32 _tmp38_;
	XnoiseTrackData* _tmp39_;
	XnoiseTrackData* _tmp40_;
	gint _tmp41_;
	XnoiseTrackData* _tmp42_;
	XnoiseTrackData* _tmp43_;
	XnoiseItem* _tmp44_;
	XnoiseItem* _tmp45_;
	XnoiseTrackData* _tmp46_;
	XnoiseTrackData* _tmp47_;
	gboolean _tmp48_;
	XnoiseTrackData* _tmp49_;
	XnoiseTrackData* _tmp50_;
	gboolean _tmp51_;
	XnoiseTrackData* _tmp52_;
	XnoiseTrackData* _tmp53_;
	GdkPixbuf* _tmp54_;
	GdkPixbuf* _tmp55_;
	XnoiseTrackData* _tmp56_;
	XnoiseTrackData* _tmp57_;
	gint32 _tmp58_;
	XnoiseTrackData* _tmp59_;
	XnoiseTrackData* _tmp60_;
	gint32 _tmp61_;
	XnoiseTrackData* _tmp62_;
	XnoiseTrackData* _tmp63_;
	gint32 _tmp64_;
	g_return_val_if_fail ((td == NULL) || XNOISE_IS_TRACK_DATA (td), NULL);
	_tmp0_ = td;
	if (_tmp0_ == NULL) {
		XnoiseTrackData* _tmp1_;
		_tmp1_ = xnoise_track_data_new ();
		result = _tmp1_;
		return result;
	}
	_tmp2_ = xnoise_track_data_new ();
	td_new = _tmp2_;
	_tmp3_ = td_new;
	_tmp4_ = td;
	_tmp5_ = _tmp4_->artist;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (_tmp3_->artist);
	_tmp3_->artist = _tmp6_;
	_tmp7_ = td_new;
	_tmp8_ = td;
	_tmp9_ = _tmp8_->albumartist;
	_tmp10_ = g_strdup (_tmp9_);
	_g_free0 (_tmp7_->albumartist);
	_tmp7_->albumartist = _tmp10_;
	_tmp11_ = td_new;
	_tmp12_ = td;
	_tmp13_ = _tmp12_->album;
	_tmp14_ = g_strdup (_tmp13_);
	_g_free0 (_tmp11_->album);
	_tmp11_->album = _tmp14_;
	_tmp15_ = td_new;
	_tmp16_ = td;
	_tmp17_ = _tmp16_->title;
	_tmp18_ = g_strdup (_tmp17_);
	_g_free0 (_tmp15_->title);
	_tmp15_->title = _tmp18_;
	_tmp19_ = td_new;
	_tmp20_ = td;
	_tmp21_ = _tmp20_->genre;
	_tmp22_ = g_strdup (_tmp21_);
	_g_free0 (_tmp19_->genre);
	_tmp19_->genre = _tmp22_;
	_tmp23_ = td_new;
	_tmp24_ = td;
	_tmp25_ = _tmp24_->mimetype;
	_tmp26_ = g_strdup (_tmp25_);
	_g_free0 (_tmp23_->mimetype);
	_tmp23_->mimetype = _tmp26_;
	_tmp27_ = td_new;
	_tmp28_ = td;
	_tmp29_ = _tmp28_->disk_number;
	_tmp27_->disk_number = _tmp29_;
	_tmp30_ = td_new;
	_tmp31_ = td;
	_tmp32_ = _tmp31_->year;
	_tmp30_->year = _tmp32_;
	_tmp33_ = td_new;
	_tmp34_ = td;
	_tmp35_ = _tmp34_->tracknumber;
	_tmp33_->tracknumber = _tmp35_;
	_tmp36_ = td_new;
	_tmp37_ = td;
	_tmp38_ = _tmp37_->length;
	_tmp36_->length = _tmp38_;
	_tmp39_ = td_new;
	_tmp40_ = td;
	_tmp41_ = _tmp40_->bitrate;
	_tmp39_->bitrate = _tmp41_;
	_tmp42_ = td_new;
	_tmp43_ = td;
	_tmp44_ = _tmp43_->item;
	_tmp45_ = _xnoise_item_dup0 (_tmp44_);
	_xnoise_item_free0 (_tmp42_->item);
	_tmp42_->item = _tmp45_;
	_tmp46_ = td_new;
	_tmp47_ = td;
	_tmp48_ = _tmp47_->is_compilation;
	_tmp46_->is_compilation = _tmp48_;
	_tmp49_ = td_new;
	_tmp50_ = td;
	_tmp51_ = _tmp50_->has_embedded_image;
	_tmp49_->has_embedded_image = _tmp51_;
	_tmp52_ = td_new;
	_tmp53_ = td;
	_tmp54_ = _tmp53_->pixbuf;
	_tmp55_ = _g_object_ref0 (_tmp54_);
	_g_object_unref0 (_tmp52_->pixbuf);
	_tmp52_->pixbuf = _tmp55_;
	_tmp56_ = td_new;
	_tmp57_ = td;
	_tmp58_ = _tmp57_->dat1;
	_tmp56_->dat1 = _tmp58_;
	_tmp59_ = td_new;
	_tmp60_ = td;
	_tmp61_ = _tmp60_->dat2;
	_tmp59_->dat2 = _tmp61_;
	_tmp62_ = td_new;
	_tmp63_ = td;
	_tmp64_ = _tmp63_->dat3;
	_tmp62_->dat3 = _tmp64_;
	result = td_new;
	return result;
}



